#include <iostream>

using namespace std;

int main() {
	
	int V, S, zb, zap, stene[999999];
	int voda[999999];
	bool f = true;
	
	cin >> V >> S;
	for (int i = 0; i < S; i++){
		
		voda[i] = 1;
		
	}
	
	
	for (int l = 0; l < V; l++) {
		zb = 0;
		zap = 0;
			for (int i = 0; i < S; i++) {
				
				cin >> stene[i];
		
				if (stene[i] == 1) {
					
					if (l % 2 == 0) {
						
						if (stene[0] == 0 && f == true) {
							voda[i] = voda[i] + zb;
							zap = i;
							f = false;
						}
						else {
							if (zb % 2 == 1) {
								voda[zap] = voda[zap] + 1;
								zb = zb - 1;
							} 
							voda[zap] += (zb / 2);
							voda[i] += (zb / 2);
							zap = i;
						}
						
					}
					else {
						
						if (stene[0] == 0 && f == true) {
							voda[i] = voda[i] + zb;
							zap = i;
						}
						else {
							if (zb % 2 == 1) {
								voda[i] = voda[i] + 1;
								zb = zb - 1;
							} 
							voda[zap] = voda[zap] + (zb / 2);
							voda[i] = voda[i] + (zb / 2);
							zap = i;
						}
						
					}
					
					zb = 0;
				}
				else {
					
					zb = zb + voda[i];
					voda[i] = 0;
					
				}
			}
		voda[zap] = voda[zap] + zb;
	}
	for (int i = 0; i < S; i++) {
		
		cout << voda[i] << " ";
		
	}
	return 0;
}